diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/mgt-headers.h ns-3.39/src/wifi/model/mgt-headers.h
--- ns-3.38/src/wifi/model/mgt-headers.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/mgt-headers.h	2023-07-05 14:23:48.113428400 -0700
@@ -534,383 +378,95 @@
      */
     uint16_t GetAssociationId() const;
     /**
-     * Return the ERP information, if present.
-     *
-     * \return the ERP information, if present
-     */
-    const std::optional<ErpInformation>& GetErpInformation() const;
-    /**
-     * Return the EDCA Parameter Set, if present.
-     *
-     * \return the EDCA Parameter Set, if present
-     */
-    const std::optional<EdcaParameterSet>& GetEdcaParameterSet() const;
-    /**
-     * Return the MU EDCA Parameter Set, if present.
-     *
-     * \return the MU EDCA Parameter Set, if present
-     */
-    const std::optional<MuEdcaParameterSet>& GetMuEdcaParameterSet() const;
-    /**
-     * Set the Capability information.
-     *
-     * \param capabilities Capability information
-     */
-    void SetCapabilities(const CapabilityInformation& capabilities);
-
-    /** \copydoc SetCapabilities */
-    void SetCapabilities(CapabilityInformation&& capabilities);
-
-    /**
-     * Set the extended capabilities.
-     *
-     * \param extendedCapabilities the extended capabilities
-     */
-    void SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities);
-
-    /** \copydoc SetExtendedCapabilities */
-    void SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities);
-
-    /**
-     * Set the VHT operation.
-     *
-     * \param vhtOperation VHT operation
-     */
-    void SetVhtOperation(const VhtOperation& vhtOperation);
-
-    /** \copydoc SetVhtOperation */
-    void SetVhtOperation(VhtOperation&& vhtOperation);
-
-    /**
-     * Set the VHT capabilities.
-     *
-     * \param vhtCapabilities VHT capabilities
-     */
-    void SetVhtCapabilities(const VhtCapabilities& vhtCapabilities);
-
-    /** \copydoc SetVhtCapabilities */
-    void SetVhtCapabilities(VhtCapabilities&& vhtCapabilities);
-
-    /**
-     * Set the HT capabilities.
-     *
-     * \param htCapabilities HT capabilities
-     */
-    void SetHtCapabilities(const HtCapabilities& htCapabilities);
-
-    /** \copydoc SetHtCapabilities */
-    void SetHtCapabilities(HtCapabilities&& htCapabilities);
-
-    /**
-     * Set the HT operation.
-     *
-     * \param htOperation HT operation
-     */
-    void SetHtOperation(const HtOperation& htOperation);
-
-    /** \copydoc SetHtOperation */
-    void SetHtOperation(HtOperation&& htOperation);
-
-    /**
-     * Set the supported rates.
-     *
-     * \param rates the supported rates
-     */
-    void SetSupportedRates(const SupportedRates& rates);
-
-    /** \copydoc SetSupportedRates */
-    void SetSupportedRates(SupportedRates&& rates);
-
-    /**
-     * Set the status code.
-     *
-     * \param code the status code
-     */
-    void SetStatusCode(StatusCode code);
-
-    /**
      * Set the association ID.
      *
      * \param aid the association ID
      */
     void SetAssociationId(uint16_t aid);
 
-    /**
-     * Set the ERP information.
-     *
-     * \param erpInformation the ERP information
-     */
-    void SetErpInformation(const ErpInformation& erpInformation);
-
-    /** \copydoc SetErpInformation */
-    void SetErpInformation(ErpInformation&& erpInformation);
+  protected:
+    /** \copydoc Header::GetSerializedSize */
+    uint32_t GetSerializedSizeImpl() const;
+    /** \copydoc Header::Serialize */
+    void SerializeImpl(Buffer::Iterator start) const;
+    /** \copydoc Header::Deserialize */
+    uint32_t DeserializeImpl(Buffer::Iterator start);
+    /** \copydoc Header::Print */
+    void PrintImpl(std::ostream& os) const;
 
     /**
-     * Set the EDCA Parameter Set.
-     *
-     * \param edcaParameterSet the EDCA Parameter Set
+     * \param frame the frame containing the Multi-Link Element
+     * \return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     *         subelement of the Multi-Link Element
      */
-    void SetEdcaParameterSet(const EdcaParameterSet& edcaParameterSet);
-
-    /** \copydoc SetEdcaParameterSet */
-    void SetEdcaParameterSet(EdcaParameterSet&& edcaParameterSet);
+    uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtAssocResponseHeader& frame) const;
 
     /**
-     * Set the MU EDCA Parameter Set.
+     * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
      *
-     * \param muEdcaParameterSet the MU EDCA Parameter Set
+     * \param start an iterator which points to where the header should be written
+     * \param frame the frame containing the Multi-Link Element
      */
-    void SetMuEdcaParameterSet(const MuEdcaParameterSet& muEdcaParameterSet);
-
-    /** \copydoc SetMuEdcaParameterSet */
-    void SetMuEdcaParameterSet(MuEdcaParameterSet&& muEdcaParameterSet);
+    void SerializeInPerStaProfileImpl(Buffer::Iterator start,
+                                      const MgtAssocResponseHeader& frame) const;
 
     /**
-     * Set the HE capabilities.
+     * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
      *
-     * \param heCapabilities HE capabilities
+     * \param start an iterator which points to where the header should be read from
+     * \param length the expected number of bytes to read
+     * \param frame the frame containing the Multi-Link Element
+     * \return the number of bytes read
      */
-    void SetHeCapabilities(const HeCapabilities& heCapabilities);
-
-    /** \copydoc SetHeCapabilities */
-    void SetHeCapabilities(HeCapabilities&& heCapabilities);
-
-    /**
-     * Set the HE operation.
-     *
-     * \param heOperation HE operation
-     */
-    void SetHeOperation(const HeOperation& heOperation);
-
-    /** \copydoc SetHeOperation */
-    void SetHeOperation(HeOperation&& heOperation);
-
-    /**
-     * Set the EHT capabilities.
-     *
-     * \param ehtCapabilities EHT capabilities
-     */
-    void SetEhtCapabilities(const EhtCapabilities& ehtCapabilities);
-
-    /** \copydoc SetEhtCapabilities */
-    void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
-
-    /**
-     * Set the EHT operation.
-     *
-     * \param ehtOperation HE operation
-     */
-    void SetEhtOperation(const EhtOperation& ehtOperation);
-
-    /** \copydoc SetEhtOperation */
-    void SetEhtOperation(EhtOperation&& ehtOperation);
-
-    /**
-     * Set the Multi-Link Element information element
-     *
-     * \param multiLinkElement the Multi-Link Element information element
-     */
-    void SetMultiLinkElement(const MultiLinkElement& multiLinkElement);
-
-    /** \copydoc SetMultiLinkElement */
-    void SetMultiLinkElement(MultiLinkElement&& multiLinkElement);
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
+    uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
+                                              uint16_t length,
+                                              const MgtAssocResponseHeader& frame);
 
   private:
-    SupportedRates m_rates;                                   //!< List of supported rates
-    CapabilityInformation m_capability;                       //!< Capability information
-    StatusCode m_code;                                        //!< Status code
-    uint16_t m_aid;                                           //!< AID
-    std::optional<ExtendedCapabilities> m_extendedCapability; //!< extended capabilities
-    std::optional<HtCapabilities> m_htCapability;             //!< HT capabilities
-    std::optional<HtOperation> m_htOperation;                 //!< HT operation
-    std::optional<VhtCapabilities> m_vhtCapability;           //!< VHT capabilities
-    std::optional<VhtOperation> m_vhtOperation;               //!< VHT operation
-    std::optional<ErpInformation> m_erpInformation;           //!< ERP information
-    std::optional<EdcaParameterSet> m_edcaParameterSet;       //!< EDCA Parameter Set
-    std::optional<HeCapabilities> m_heCapability;             //!< HE capabilities
-    std::optional<HeOperation> m_heOperation;                 //!< HE operation
-    std::optional<MuEdcaParameterSet> m_muEdcaParameterSet;   //!< MU EDCA Parameter Set
-    std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
-    std::optional<EhtOperation> m_ehtOperation;               //!< EHT Operation
-    std::optional<MultiLinkElement> m_multiLinkElement;       //!< Multi-Link Element
+    CapabilityInformation m_capability; //!< Capability information
+    StatusCode m_code;                  //!< Status code
+    uint16_t m_aid{0};                  //!< AID
 };
 
 /**
  * \ingroup wifi
  * Implement the header for management frames of type probe request.
  */
-class MgtProbeRequestHeader : public Header
+class MgtProbeRequestHeader : public WifiMgtHeader<MgtProbeRequestHeader, ProbeRequestElems>
 {
   public:
-    ~MgtProbeRequestHeader() override;
-
-    /**
-     * Set the Service Set Identifier (SSID).
-     *
-     * \param ssid SSID
-     */
-    void SetSsid(const Ssid& ssid);
-
-    /** \copydoc SetSsid */
-    void SetSsid(Ssid&& ssid);
-
-    /**
-     * Set the supported rates.
-     *
-     * \param rates the supported rates
-     */
-    void SetSupportedRates(const SupportedRates& rates);
-
-    /** \copydoc SetSupportedRates */
-    void SetSupportedRates(SupportedRates&& rates);
-
-    /**
-     * Set the extended capabilities.
-     *
-     * \param extendedCapabilities the extended capabilities
-     */
-    void SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities);
-
-    /** \copydoc SetExtendedCapabilities */
-    void SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities);
-
-    /**
-     * Set the HT capabilities.
-     *
-     * \param htCapabilities HT capabilities
-     */
-    void SetHtCapabilities(const HtCapabilities& htCapabilities);
-
-    /** \copydoc SetHtCapabilities */
-    void SetHtCapabilities(HtCapabilities&& htCapabilities);
-
-    /**
-     * Set the VHT capabilities.
-     *
-     * \param vhtCapabilities VHT capabilities
-     */
-    void SetVhtCapabilities(const VhtCapabilities& vhtCapabilities);
-
-    /** \copydoc SetVhtCapabilities */
-    void SetVhtCapabilities(VhtCapabilities&& vhtCapabilities);
-
-    /**
-     * Set the HE capabilities.
-     *
-     * \param heCapabilities HE capabilities
-     */
-    void SetHeCapabilities(const HeCapabilities& heCapabilities);
-
-    /** \copydoc SetHeCapabilities */
-    void SetHeCapabilities(HeCapabilities&& heCapabilities);
-
-    /**
-     * Set the EHT capabilities.
-     *
-     * \param ehtCapabilities EHT capabilities
-     */
-    void SetEhtCapabilities(const EhtCapabilities& ehtCapabilities);
-
-    /** \copydoc SetEhtCapabilities */
-    void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
-
-    /**
-     * Return the Service Set Identifier (SSID).
-     *
-     * \return SSID
-     */
-    const Ssid& GetSsid() const;
-
-    /**
-     * Return the supported rates.
-     *
-     * \return the supported rates
-     */
-    const SupportedRates& GetSupportedRates() const;
-
-    /**
-     * Return the extended capabilities, if present.
-     *
-     * \return the extended capabilities, if present
-     */
-    const std::optional<ExtendedCapabilities>& GetExtendedCapabilities() const;
-
-    /**
-     * Return the HT capabilities, if present.
-     *
-     * \return HT capabilities, if present
-     */
-    const std::optional<HtCapabilities>& GetHtCapabilities() const;
-
-    /**
-     * Return the VHT capabilities, if present.
-     *
-     * \return VHT capabilities, if present
-     */
-    const std::optional<VhtCapabilities>& GetVhtCapabilities() const;
-
-    /**
-     * Return the HE capabilities, if present.
-     *
-     * \return HE capabilities, if present
-     */
-    const std::optional<HeCapabilities>& GetHeCapabilities() const;
-
-    /**
-     * Return the EHT capabilities, if present.
-     *
-     * \return EHT capabilities, if present
-     */
-    const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
+    ~MgtProbeRequestHeader() override = default;
 
     /**
      * Register this type.
      * \return The TypeId.
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
 
-  private:
-    Ssid m_ssid;                                              //!< Service Set ID (SSID)
-    SupportedRates m_rates;                                   //!< List of supported rates
-    std::optional<ExtendedCapabilities> m_extendedCapability; //!< extended capabilities
-    std::optional<HtCapabilities> m_htCapability;             //!< HT capabilities
-    std::optional<VhtCapabilities> m_vhtCapability;           //!< VHT capabilities
-    std::optional<HeCapabilities> m_heCapability;             //!< HE capabilities
-    std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
+    /** \copydoc Header::GetInstanceTypeId */
+    TypeId GetInstanceTypeId() const override;
 };
 
 /**
  * \ingroup wifi
  * Implement the header for management frames of type probe response.
  */
-class MgtProbeResponseHeader : public Header
+class MgtProbeResponseHeader : public WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>
 {
+    friend class WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>;
+
   public:
-    MgtProbeResponseHeader();
-    ~MgtProbeResponseHeader() override;
+    ~MgtProbeResponseHeader() override = default;
 
     /**
-     * Return the Service Set Identifier (SSID).
-     *
-     * \return SSID
+     * Register this type.
+     * \return The TypeId.
      */
-    const Ssid& GetSsid() const;
+    static TypeId GetTypeId();
+
+    /** \copydoc Header::GetInstanceTypeId */
+    TypeId GetInstanceTypeId() const override;
+
     /**
      * Return the beacon interval in microseconds unit.
      *
@@ -918,295 +474,19 @@
      */
     uint64_t GetBeaconIntervalUs() const;
     /**
-     * Return the supported rates.
-     *
-     * \return the supported rates
-     */
-    const SupportedRates& GetSupportedRates() const;
-    /**
-     * Return the Capability information.
-     *
-     * \return Capability information
-     */
-    const CapabilityInformation& GetCapabilities() const;
-    /**
-     * Return the DSSS Parameter Set, if present.
-     *
-     * \return the DSSS Parameter Set, if present
-     */
-    const std::optional<DsssParameterSet>& GetDsssParameterSet() const;
-    /**
-     * Return the extended capabilities, if present.
-     *
-     * \return the extended capabilities, if present
-     */
-    const std::optional<ExtendedCapabilities>& GetExtendedCapabilities() const;
-    /**
-     * Return the HT capabilities, if present.
-     *
-     * \return HT capabilities, if present
-     */
-    const std::optional<HtCapabilities>& GetHtCapabilities() const;
-    /**
-     * Return the HT operation, if present.
-     *
-     * \return HT operation, if present
-     */
-    const std::optional<HtOperation>& GetHtOperation() const;
-    /**
-     * Return the VHT capabilities, if present.
-     *
-     * \return VHT capabilities, if present
-     */
-    const std::optional<VhtCapabilities>& GetVhtCapabilities() const;
-    /**
-     * Return the VHT operation, if present.
-     *
-     * \return VHT operation, if present
-     */
-    const std::optional<VhtOperation>& GetVhtOperation() const;
-    /**
-     * Return the HE capabilities, if present.
-     *
-     * \return HE capabilities, if present
-     */
-    const std::optional<HeCapabilities>& GetHeCapabilities() const;
-    /**
-     * Return the HE operation, if present.
-     *
-     * \return HE operation, if present
-     */
-    const std::optional<HeOperation>& GetHeOperation() const;
-    /**
-     * Return the EHT capabilities, if present.
-     *
-     * \return EHT capabilities, if present
-     */
-    const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
-    /**
-     * Return the EHT operation, if present.
-     *
-     * \return EHT operation, if present
-     */
-    const std::optional<EhtOperation>& GetEhtOperation() const;
-    /**
-     * Return the ERP information, if present.
-     *
-     * \return the ERP information, if present
-     */
-    const std::optional<ErpInformation>& GetErpInformation() const;
-    /**
-     * Return the EDCA Parameter Set, if present.
-     *
-     * \return the EDCA Parameter Set, if present
-     */
-    const std::optional<EdcaParameterSet>& GetEdcaParameterSet() const;
-    /**
-     * Return the MU EDCA Parameter Set, if present.
-     *
-     * \return the MU EDCA Parameter Set, if present
-     */
-    const std::optional<MuEdcaParameterSet>& GetMuEdcaParameterSet() const;
-
-    /**
-     * Return the Reduced Neighbor Report information element, if present.
-     *
-     * \return the Reduced Neighbor Report information element, if present
-     */
-    const std::optional<ReducedNeighborReport>& GetReducedNeighborReport() const;
-    /**
-     * Return the Multi-Link Element information element, if present.
-     *
-     * \return the Multi-Link Element information element, if present
-     */
-    const std::optional<MultiLinkElement>& GetMultiLinkElement() const;
-    /**
-     * Set the Capability information.
-     *
-     * \param capabilities Capability information
-     */
-    void SetCapabilities(const CapabilityInformation& capabilities);
-
-    /** \copydoc SetCapabilities */
-    void SetCapabilities(CapabilityInformation&& capabilities);
-
-    /**
-     * Set the extended capabilities.
-     *
-     * \param extendedCapabilities the extended capabilities
-     */
-    void SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities);
-
-    /** \copydoc SetExtendedCapabilities */
-    void SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities);
-
-    /**
-     * Set the HT capabilities.
-     *
-     * \param htCapabilities HT capabilities
-     */
-    void SetHtCapabilities(const HtCapabilities& htCapabilities);
-
-    /** \copydoc SetHtCapabilities */
-    void SetHtCapabilities(HtCapabilities&& htCapabilities);
-
-    /**
-     * Set the HT operation.
-     *
-     * \param htOperation HT operation
-     */
-    void SetHtOperation(const HtOperation& htOperation);
-
-    /** \copydoc SetHtOperation */
-    void SetHtOperation(HtOperation&& htOperation);
-
-    /**
-     * Set the VHT capabilities.
-     *
-     * \param vhtCapabilities VHT capabilities
-     */
-    void SetVhtCapabilities(const VhtCapabilities& vhtCapabilities);
-
-    /** \copydoc SetVhtCapabilities */
-    void SetVhtCapabilities(VhtCapabilities&& vhtCapabilities);
-
-    /**
-     * Set the VHT operation.
-     *
-     * \param vhtOperation VHT operation
-     */
-    void SetVhtOperation(const VhtOperation& vhtOperation);
-
-    /** \copydoc SetVhtOperation */
-    void SetVhtOperation(VhtOperation&& vhtOperation);
-
-    /**
-     * Set the HE capabilities.
-     *
-     * \param heCapabilities HE capabilities
-     */
-    void SetHeCapabilities(const HeCapabilities& heCapabilities);
-
-    /** \copydoc SetHeCapabilities */
-    void SetHeCapabilities(HeCapabilities&& heCapabilities);
-
-    /**
-     * Set the HE operation.
-     *
-     * \param heOperation HE operation
-     */
-    void SetHeOperation(const HeOperation& heOperation);
-
-    /** \copydoc SetHeOperation */
-    void SetHeOperation(HeOperation&& heOperation);
-
-    /**
-     * Set the EHT capabilities.
-     *
-     * \param ehtCapabilities EHT capabilities
-     */
-    void SetEhtCapabilities(const EhtCapabilities& ehtCapabilities);
-
-    /** \copydoc SetEhtCapabilities */
-    void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
-
-    /**
-     * Set the EHT operation.
-     *
-     * \param ehtOperation HE operation
-     */
-    void SetEhtOperation(const EhtOperation& ehtOperation);
-
-    /** \copydoc SetEhtOperation */
-    void SetEhtOperation(EhtOperation&& ehtOperation);
-
-    /**
-     * Set the Service Set Identifier (SSID).
-     *
-     * \param ssid SSID
-     */
-    void SetSsid(const Ssid& ssid);
-
-    /** \copydoc SetSsid */
-    void SetSsid(Ssid&& ssid);
-
-    /**
      * Set the beacon interval in microseconds unit.
      *
      * \param us beacon interval in microseconds unit
      */
     void SetBeaconIntervalUs(uint64_t us);
-
     /**
-     * Set the supported rates.
-     *
-     * \param rates the supported rates
+     * \return a reference to the Capability information
      */
-    void SetSupportedRates(const SupportedRates& rates);
-
-    /** \copydoc SetSupportedRates */
-    void SetSupportedRates(SupportedRates&& rates);
-
+    CapabilityInformation& Capabilities();
     /**
-     * Set the DSSS Parameter Set.
-     *
-     * \param dsssParameterSet the DSSS Parameter Set
+     * \return a const reference to the Capability information
      */
-    void SetDsssParameterSet(const DsssParameterSet& dsssParameterSet);
-
-    /** \copydoc SetDsssParameterSet */
-    void SetDsssParameterSet(DsssParameterSet&& dsssParameterSet);
-
-    /**
-     * Set the ERP information.
-     *
-     * \param erpInformation the ERP information
-     */
-    void SetErpInformation(const ErpInformation& erpInformation);
-
-    /** \copydoc SetErpInformation */
-    void SetErpInformation(ErpInformation&& erpInformation);
-
-    /**
-     * Set the EDCA Parameter Set.
-     *
-     * \param edcaParameterSet the EDCA Parameter Set
-     */
-    void SetEdcaParameterSet(const EdcaParameterSet& edcaParameterSet);
-
-    /** \copydoc SetEdcaParameterSet */
-    void SetEdcaParameterSet(EdcaParameterSet&& edcaParameterSet);
-
-    /**
-     * Set the MU EDCA Parameter Set.
-     *
-     * \param muEdcaParameterSet the MU EDCA Parameter Set
-     */
-    void SetMuEdcaParameterSet(const MuEdcaParameterSet& muEdcaParameterSet);
-
-    /** \copydoc SetMuEdcaParameterSet */
-    void SetMuEdcaParameterSet(MuEdcaParameterSet&& muEdcaParameterSet);
-
-    /**
-     * Set the Reduced Neighbor Report information element
-     *
-     * \param reducedNeighborReport the Reduced Neighbor Report information element
-     */
-    void SetReducedNeighborReport(const ReducedNeighborReport& reducedNeighborReport);
-
-    /** \copydoc SetReducedNeighborReport */
-    void SetReducedNeighborReport(ReducedNeighborReport&& reducedNeighborReport);
-
-    /**
-     * Set the Multi-Link Element information element
-     *
-     * \param multiLinkElement the Multi-Link Element information element
-     */
-    void SetMultiLinkElement(const MultiLinkElement& multiLinkElement);
-
-    /** \copydoc SetMultiLinkElement */
-    void SetMultiLinkElement(MultiLinkElement&& multiLinkElement);
-
+    const CapabilityInformation& Capabilities() const;
     /**
      * Return the time stamp.
      *
@@ -1214,39 +494,18 @@
      */
     uint64_t GetTimestamp() const;
 
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
+  protected:
+    /** \copydoc Header::GetSerializedSize */
+    uint32_t GetSerializedSizeImpl() const;
+    /** \copydoc Header::Serialize*/
+    void SerializeImpl(Buffer::Iterator start) const;
+    /** \copydoc Header::Deserialize */
+    uint32_t DeserializeImpl(Buffer::Iterator start);
 
   private:
-    uint64_t m_timestamp;                                     //!< Timestamp
-    Ssid m_ssid;                                              //!< Service set ID (SSID)
-    uint64_t m_beaconInterval;                                //!< Beacon interval
-    SupportedRates m_rates;                                   //!< List of supported rates
-    CapabilityInformation m_capability;                       //!< Capability information
-    std::optional<DsssParameterSet> m_dsssParameterSet;       //!< DSSS Parameter Set
-    std::optional<ExtendedCapabilities> m_extendedCapability; //!< extended capabilities
-    std::optional<HtCapabilities> m_htCapability;             //!< HT capabilities
-    std::optional<HtOperation> m_htOperation;                 //!< HT operation
-    std::optional<VhtCapabilities> m_vhtCapability;           //!< VHT capabilities
-    std::optional<VhtOperation> m_vhtOperation;               //!< VHT operation
-    std::optional<HeCapabilities> m_heCapability;             //!< HE capabilities
-    std::optional<HeOperation> m_heOperation;                 //!< HE operation
-    std::optional<ErpInformation> m_erpInformation;           //!< ERP information
-    std::optional<EdcaParameterSet> m_edcaParameterSet;       //!< EDCA Parameter Set
-    std::optional<MuEdcaParameterSet> m_muEdcaParameterSet;   //!< MU EDCA Parameter Set
-    std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
-    std::optional<EhtOperation> m_ehtOperation;               //!< EHT Operation
-    std::optional<ReducedNeighborReport>
-        m_reducedNeighborReport;                        //!< Reduced Neighbor Report information
-    std::optional<MultiLinkElement> m_multiLinkElement; //!< Multi-Link Element
+    uint64_t m_timestamp;               //!< Timestamp
+    uint64_t m_beaconInterval;          //!< Beacon interval
+    CapabilityInformation m_capability; //!< Capability information
 };
 
 /**
@@ -1256,7 +515,8 @@
 class MgtBeaconHeader : public MgtProbeResponseHeader
 {
   public:
-    /** Register this type. */
+    ~MgtBeaconHeader() override = default;
+
     /**
      * Register this type.
      * \return The TypeId.
@@ -1287,7 +547,7 @@
      */
 
     /// CategoryValue enumeration
-    enum CategoryValue // table 8-38 staring from IEEE 802.11, Part11, (Year 2012)
+    enum CategoryValue // table 9-51 of IEEE 802.11-2020
     {
         QOS = 1,
         BLOCK_ACK = 3,
@@ -1299,6 +559,7 @@
         DMG = 16,              // Category: DMG
         FST = 18,              // Category: Fast Session Transfer
         UNPROTECTED_DMG = 20,  // Category: Unprotected DMG
+        PROTECTED_EHT = 37,    // Category: Protected EHT
         // Since vendor specific action has no stationary Action value,the parse process is not
         // here. Refer to vendor-specific-action in wave module.
         VENDOR_SPECIFIC_ACTION = 127,
@@ -1354,9 +615,9 @@
             4, // Action Value:4 in Category 13: Mesh MCCA-Setup-Request (not used so far)
         MDA_SETUP_REPLY =
             5, // Action Value:5 in Category 13: Mesh MCCA-Setup-Reply (not used so far)
-        MDAOP_ADVERTISMENT_REQUEST =
+        MDAOP_ADVERTISEMENT_REQUEST =
             6, // Action Value:6 in Category 13: Mesh MCCA-Advertisement-Request (not used so far)
-        MDAOP_ADVERTISMENTS = 7,       // Action Value:7 in Category 13: Mesh (not used so far)
+        MDAOP_ADVERTISEMENTS = 7,      // Action Value:7 in Category 13: Mesh (not used so far)
         MDAOP_SET_TEARDOWN = 8,        // Action Value:8 in Category 13: Mesh (not used so far)
         TBTT_ADJUSTMENT_REQUEST = 9,   // Action Value:9 in Category 13: Mesh (not used so far)
         TBTT_ADJUSTMENT_RESPONSE = 10, // Action Value:10 in Category 13: Mesh (not used so far)
@@ -1439,6 +700,24 @@
     };
 
     /**
+     * Protected EHT action field values
+     * See 802.11be D3.0 Table 9-623c
+     */
+    enum ProtectedEhtActionValue
+    {
+        PROTECTED_EHT_TID_TO_LINK_MAPPING_REQUEST = 0,
+        PROTECTED_EHT_TID_TO_LINK_MAPPING_RESPONSE = 1,
+        PROTECTED_EHT_TID_TO_LINK_MAPPING_TEARDOWN = 2,
+        PROTECTED_EHT_EPCS_PRIORITY_ACCESS_ENABLE_REQUEST = 3,
+        PROTECTED_EHT_EPCS_PRIORITY_ACCESS_ENABLE_RESPONSE = 4,
+        PROTECTED_EHT_EPCS_PRIORITY_ACCESS_TEARDOWN = 5,
+        PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION = 6,
+        PROTECTED_EHT_LINK_RECOMMENDATION = 7,
+        PROTECTED_EHT_MULTI_LINK_OPERATION_UPDATE_REQUEST = 8,
+        PROTECTED_EHT_MULTI_LINK_OPERATION_UPDATE_RESPONSE = 9,
+    };
+
+    /**
      * typedef for union of different ActionValues
      */
     typedef union {
@@ -1452,6 +731,7 @@
         DmgActionValue dmgAction;                           ///< dmg
         FstActionValue fstAction;                           ///< fst
         UnprotectedDmgActionValue unprotectedDmgAction;     ///< unprotected dmg
+        ProtectedEhtActionValue protectedEhtAction;         ///< protected eht
     } ActionValue;                                          ///< the action value
 
     /**
@@ -1476,6 +756,22 @@
     ActionValue GetAction() const;
 
     /**
+     * Peek an Action header from the given packet.
+     *
+     * \param pkt the given packet
+     * \return the category value and the action value in the peeked Action header
+     */
+    static std::pair<CategoryValue, ActionValue> Peek(Ptr<const Packet> pkt);
+
+    /**
+     * Remove an Action header from the given packet.
+     *
+     * \param pkt the given packet
+     * \return the category value and the action value in the removed Action header
+     */
+    static std::pair<CategoryValue, ActionValue> Remove(Ptr<Packet> pkt);
+
+    /**
      * Register this type.
      * \return The TypeId.
      */
@@ -1487,18 +783,6 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 
   private:
-    /**
-     * Category value to string function
-     * \param value the category value
-     * \returns the category value string
-     */
-    std::string CategoryValueToString(CategoryValue value) const;
-    /**
-     * Self protected action value to string function
-     * \param value the protected action value
-     * \returns the self protected action value string
-     */
-    std::string SelfProtectedActionValueToString(SelfProtectedActionValue value) const;
     uint8_t m_category;    //!< Category of the action
     uint8_t m_actionValue; //!< Action value
 };
